------ Differences with Spagic 2.0.0 ------

-- Solve SPAGIC-153 BUGS
-- IF USING SPAGIC 2.0 spagic-metadb-oracle.ddl
-- IN SPAGIC 2.1 THIS IS NOT REQUIRED
ALTER TABLE PROCESS modify process_version varchar2(20);

-- ENABLE THE PROPERTY NAME ( code ) TO BE LONG 200  
ALTER TABLE PROPERTY MODIFY code Varchar2(200);

-- Timestamp changes
ALTER TABLE process_instance MODIFY startdate Timestamp;


ALTER TABLE process_instance MODIFY enddate Timestamp; 

ALTER TABLE log_journal MODIFY datelog Timestamp;

ALTER TABLE process MODIFY startdate Timestamp;
ALTER TABLE process MODIFY enddate Timestamp;

ALTER TABLE transition_instance MODIFY transition_start Timestamp;
ALTER TABLE transition_instance MODIFY transition_end Timestamp;

ALTER TABLE rule MODIFY start_date Timestamp;
ALTER TABLE rule MODIFY end_date Timestamp;


------ Differences with Spagic 2.1.0 ------

ALTER TABLE TRANSITION_INSTANCE ADD (attachment_in Integer DEFAULT 0);

ALTER TABLE TRANSITION_INSTANCE ADD (attachment_out Integer DEFAULT 0);

ALTER TABLE PROCESS ADD (monitor_enabled Char(1) DEFAULT 1);

ALTER TABLE TRANSITION_INSTANCE ADD ( transition_data_out BLOB );


-- Exceution Time ( AZ 09/07/2008 )
ALTER TABLE transition_instance ADD ( transition_execution_time Integer DEFAULT NULL);
ALTER TABLE process_instance ADD ( executiontime Integer DEFAULT NULL);

-- Ricalcola tempi di esecuzione
UPDATE process_instance
SET executiontime = (EXTRACT (DAY from (enddate-startdate))*86400 +
                    EXTRACT(HOUR from (enddate-startdate))*24*60 +
                    EXTRACT(MINUTE from (enddate-startdate))*60 +
                    EXTRACT(SECOND from (enddate-startdate)))*1000; 

-- Changes for Deploy Tool
ALTER TABLE attribute ADD CONSTRAINT UNIQUE name (name);


--
-- Patch to apply to Spagic 2.3.0 to get Search Query Functionality and Binding Component View
-- Apply to Cesena Environment
--

CREATE SEQUENCE seq_search_query;

Create table search_query (
   id_query Integer NOT NULL ,
   label Varchar(100) NOT NULL UNIQUE,
   query Clob NOT NULL,
Primary Key (id_query));


CREATE VIEW bc_input_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS input_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)				
				AND s.id_step = t.id_step_source
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start = 1 AND logJournal.id_state IN (0, 3)) 
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=3 )
						) 				
	group by s.id_step;

CREATE VIEW bc_output_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS output_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_end = 1 AND logJournal.id_state=1 AND s.id_step = t.id_step_target)
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND s.id_step = t.id_step_source AND logJournal.id_state=4 )
            OR (s.is_start = 1 AND logJournal.id_state = 4 AND s.id_step = t.id_step_source)						
						) 				
	group by s.id_step;
	
CREATE VIEW bc_error_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS error_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start = 1 AND s.id_step = t.id_step_source AND logJournal.id_state IN (2, 5))
						OR(s.is_end = 1 AND s.id_step = t.id_step_target AND logJournal.id_state IN (2, 5))
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=5
								AND (s.id_step = t.id_step_target OR s.id_step = t.id_step_source))
						) 				
	group by s.id_step;


-- Differences with Spagic 2.3.0 --

ALTER TABLE process_instance DROP INDEX idx_correlation_id,
 ADD INDEX idx_process_instance_01 (id_correlation);
/* Cannot be unique due to restarted instances */
Create Index idx_transition_instance_01 ON transition_instance (id_message);
Create Index idx_log_journal_01 ON log_journal (id_journal);
Create Index idx_log_journal_02 ON log_journal (id_state);



-- Differences from spagic 2.4.0
ALTER TABLE process_instance ADD ( id_parent_process_instance Integer DEFAULT NULL );
ALTER TABLE process_instance add foreign key (id_parent_process_instance) references process_instance (id_process_instance);

Create table sub_process (
	id_process Integer NOT NULL ,
	id_subprocess Integer NOT NULL ,
	descr Varchar2 (50),
primary key (id_process,id_subprocess) 
) 
;


ALTER TABLE sub_process add foreign key (id_process) references process (id_process);
ALTER TABLE sub_process add foreign key (id_subprocess) references process (id_process);

INSERT INTO type_service (id_ts, value) VALUES(6, 'JBPM-PROCESS');

INSERT INTO transition_state (id_state,state_value) VALUES(21, 'JBPM_START_ACTIVITY');
INSERT INTO transition_state (id_state,state_value) VALUES(22, 'JBPM_END_ACTIVITY');
INSERT INTO transition_state (id_state,state_value) VALUES(23, 'JBPM_FAULTED_ACTIVITY');

ALTER TABLE process_instance ADD ( id_process_execution_state Integer Default 0 NOT NULL );
ALTER TABLE process ADD ( id_monitoring_type Integer Default 0 NOT NULL );

Create table process_execution_state (
	id_process_execution_state Integer NOT NULL ,
	state_value Varchar2 (100),
primary key (id_process_execution_state) 
) 
;

Create table monitoring_type (
	id_monitoring_type Integer NOT NULL ,
	type_value Varchar2 (100),
primary key (id_monitoring_type) 
) 
;


INSERT INTO pool_type (id_pool_type,id_rule_det_pool_type,name,description,pool_type_version) VALUES(seq_pool_type.NEXTVAL,NULL,'ANONYMOUS','POOL TYPE FOR DYNAMIC LINKS','0');

INSERT INTO process_execution_state (id_process_execution_state,state_value) VALUES(0, 'NORMAL_EXECUTION');
INSERT INTO process_execution_state (id_process_execution_state,state_value) VALUES(1, 'PAUSE_EXECUTION');
INSERT INTO process_execution_state (id_process_execution_state,state_value) VALUES(2, 'STOP_EXECUTION');

INSERT INTO monitoring_type (id_monitoring_type,type_value) VALUES(0, 'ASYNCHRONOUS');
INSERT INTO monitoring_type (id_monitoring_type,type_value) VALUES(1, 'SYNCHRONOUS');


ALTER TABLE process_instance add  foreign key (id_process_execution_state) references process_execution_state (id_process_execution_state) 
;

ALTER TABLE process add  foreign key (id_monitoring_type) references monitoring_type (id_monitoring_type) 
;


-- FLAG CONDITIONAL EXIT
ALTER TABLE step ADD ( has_conditional_exit Char(1) DEFAULT 0 );

CREATE OR REPLACE VIEW TASK_VIEW
(ID_PROCESS_INSTANCE, TASK_NAME, STATE, HAS_CONDITIONAL_EXIT)
AS
SELECT
	ti.id_process_instance,
	prop_jbpm_name.value as task_name,
	DECODE(ti.id_state, '21', 'GENERATED', '22', 'COMPLETED', '23', 'ERROR', NULL) as state,
	st.has_conditional_exit
FROM
	transition_instance ti,
	step st,
	property prop_jbpm_name,
	property_step ps
WHERE
	ti.id_step_source = st.id_step
	and ps.id_step = ti.id_step_source
	and ps.id_property = prop_jbpm_name.id_property
	and prop_jbpm_name.code = 'jbpm_step_name'
UNION ALL
SELECT
	ti.id_process_instance,
	prop_jbpm_name.value as task_name,
	DECODE(ti.id_state, '21', 'GENERATED', '22', 'COMPLETED', '23', 'ERROR', NULL) as state,
	st.has_conditional_exit
FROM
	transition_instance ti,
	step st,
	property prop_jbpm_name,
	property_step ps
WHERE
	ti.id_step_target = st.id_step
	and ps.id_step = ti.id_step_target
	and ps.id_property = prop_jbpm_name.id_property
	and prop_jbpm_name.code = 'jbpm_step_name';
	
    
-- Transition_data as CLOB in Transition Instance --
-- Old data in the columns transition_data and transition_data_out
-- won't be valid anymore
	
ALTER TABLE transition_instance DROP COLUMN transition_data;
ALTER TABLE transition_instance ADD (transition_data CLOB);
ALTER TABLE transition_instance DROP COLUMN transition_data_out;
ALTER TABLE transition_instance ADD (transition_data_out CLOB);

ALTER TABLE transition_instance MODIFY ID_EXT_PROCESS_INSTANCE Integer;


-- 2.5.0 performance improvement in backup
Create table temporary_process_instance (
	id_process_instance Integer NOT NULL ,
primary key (id_process_instance) 
) 
;

ALTER TABLE transition_instance ADD (runtime_warning Char(1) DEFAULT 0);

------ Differences with Spagic 2.5.1 ------

--  add documentation to a workflow step
ALTER TABLE step ADD (documentation BLOB DEFAULT NULL);
ALTER TABLE step ADD (documentationMimeType VARCHAR2(150) DEFAULT NULL);
ALTER TABLE step ADD (documentationFileName VARCHAR2(150) DEFAULT NULL);

-- save preferred search query
ALTER TABLE SEARCH_QUERY DROP COLUMN QUERY;
ALTER TABLE SEARCH_QUERY ADD (QUERY CLOB);

-- Add step status for start and stop
ALTER TABLE step ADD (state Integer Default 0 NOT NULL);

-- Variable management
Create table variable_instance (
	id_variable_instance Integer NOT NULL ,
	id_variable_definition Integer,
	name Varchar2 (100) NOT NULL ,
	value Clob,
	id_process_instance Integer NOT NULL ,
primary key (id_variable_instance) 
);

Create table variable_definition (
	id_variable_definition Integer NOT NULL ,
	name Varchar2 (100) NOT NULL ,
	varSchema Clob,
	id_process Integer NOT NULL ,
primary key (id_variable_definition) 
);

Create table log_journal_type (
	id_log_journal_type Integer NOT NULL ,
	type_journal Varchar2 (50) NOT NULL 
);

ALTER TABLE variable_instance add  foreign key (id_process_instance) references process_instance (id_process_instance);
ALTER TABLE variable_definition add  foreign key (id_process) references process (id_process);
ALTER TABLE variable_instance add  foreign key (id_variable_definition) references variable_definition (id_variable_definition);

INSERT INTO log_journal_type (id_log_journal_type, type_journal) VALUES(0, 'MESSAGE');
INSERT INTO log_journal_type (id_log_journal_type, type_journal) VALUES(1, 'VARIABLE');

ALTER TABLE log_journal ADD (id_log_journal_type Integer NOT NULL DEFAULT 0);

/* SPAGIC-464 */
ALTER TABLE relevant_data DROP FOREIGN KEY relevant_data_ibfk_1;
ALTER TABLE relevant_data DROP INDEX id_log;
ALTER TABLE relevant_data DROP COLUMN id_log;

/* SPAGIC-106*/
ALTER TABLE process_instance ADD COLUMN server VARCHAR2(50);

/* SPAGIC 3 */
INSERT INTO type_service (id_ts, value) VALUES(7, 'OSGI-CONNECTOR');
INSERT INTO type_service (id_ts, value) VALUES(8, 'OSGI-SERVICE');

Create table component (
	id_component Integer NOT NULL ,
	id_ts Integer NOT NULL ,
	name Varchar2 (100) NOT NULL ,
	state Integer NOT NULL ,
primary key (id_component) 
) 
;

Create table service (
	id_service Varchar2 (300) NOT NULL ,
	id_component Integer NOT NULL ,
	state Integer,
	monitor_enabled Char (1),
	startdate Timestamp(0) NOT NULL ,
	enddate Timestamp(0),
primary key (id_service) 
) 
;

Create table service_instance (
	id_service_instance Integer NOT NULL ,
	id_target_service_instance Integer,
	id_service Varchar2 (300) NOT NULL ,
	message_id Varchar2 (300) NOT NULL ,
	correlation_id Varchar2 (300) NOT NULL ,
	request Clob,
	response Clob,
	state Integer NOT NULL ,
	startdate Timestamp(0) NOT NULL ,
	enddate Timestamp(0),
primary key (id_service_instance) 
) 
;

Create table property_service (
	id_service Varchar2 (50) NOT NULL ,
	id_property Integer NOT NULL ,
primary key (id_service,id_property) 
) 
;

Create table property_component (
	id_property Integer NOT NULL ,
	id_component Integer NOT NULL ,
primary key (id_property,id_component) 
) 
;

Create table property_service_instance (
	id_property Integer NOT NULL  UNIQUE ,
	code Varchar2 (100) NOT NULL ,
	value Varchar2 (500) NOT NULL ,
	id_service_instance Integer NOT NULL ,
primary key (id_property) 
) 
;

Create Index idx_service_instance_01 ON service_instance (message_id);
Create Index idx_service_instance_02 ON service_instance (correlation_id);

Alter table property_service add Foreign Key (id_property) references property (id_property);
Alter table property_component add Foreign Key (id_property) references property (id_property);
Alter table component add Foreign Key (id_ts) references type_service (id_ts);
Alter table service add Foreign Key (id_component) references component (id_component);
Alter table property_component add Foreign Key (id_component) references component (id_component);
Alter table service_instance add Foreign Key (id_service) references service (id_service);
Alter table property_service add Foreign Key (id_service) references service (id_service);
Alter table service_instance add Foreign Key (id_target_service_instance) references service_instance (id_service_instance);
Alter table property_service_instance add Foreign Key (id_service_instance) references service_instance (id_service_instance);

CREATE SEQUENCE seq_component;
CREATE SEQUENCE seq_service_instance;
CREATE SEQUENCE seq_property_service_instance;

Create table schema_metadata (
	id_metadata Varchar(100) NOT NULL,
	data_schema Clob NOT NULL,
 Primary Key (id_metadata));

/*SPAGIC 3.0 */
Alter table rule add variable_name Varchar2(200);

/* Restart management */
Alter table process_instance add restarted Char (1) Default 0;

/* SPAGIC-690 */
Alter table transition_instance add attachment_id Varchar2 (500) DEFAULT null;
Alter table transition_instance drop COLUMN transition_data;
Alter table transition_instance drop COLUMN transition_data_out;
Alter table transition_instance drop COLUMN attachment_out;

------ Differences with Spagic 3.0.0 ------

Alter table service_instance add error Clob DEFAULT NULL;

------ Differences with Spagic 3.1.0 ------

Create table attachments (
  id                   Varchar2(200) NOT NULL,
  id_process_instance  Integer ,
  attachment_data      Blob NOT NULL,
  attachment_name	   Varchar2(100),
  content_type         Varchar2(50) NOT NULL,
  primary key (id)
); 
